#ifndef BMSBEL_BMS_H_
#define BMSBEL_BMS_H_

#include "bms_define.h"
#include "bms_word.h"
#include "bms_header_table.h"
#include "bms_regist_array.h"
#include "bms_channel.h"
#include "bms_bar.h"

// -- BmsBms -------------------------------------------------------------
class BmsBms {
public:
  explicit BmsBms( void );
  ~BmsBms();

  BmsHeaderTable&    GetHeaders( void );
  BmsRegistArraySet& GetRegistArraySet( void );
  BmsChannelManager& GetChannelManager( void );
  BmsBarManager&     GetBarManager( void );

  // IuWF݂ő̏ߐ擾
  int GetObjectExistsMaxBarPosition( void ) const;

  void MultiplyBarDivisionCount( unsigned int multiplier );

  void Merge( const BmsBms& other );

  std::string ToString( void ) const;

  void Clear( void );

private:
  BmsHeaderTable    headers_;
  BmsRegistArraySet array_set_;
  BmsChannelManager channel_manager_;
  BmsBarManager     bar_manager_;
};

#endif // BMSBEL_BMS_H_
