#ifndef BMSBEL_DEFINE_H_
#define BMSBEL_DEFINE_H_

#include <limits>

#ifndef NOT_USE_VAR
#define NOT_USE_VAR( var ) ((void)var)
#endif

#ifndef NOT
#define NOT( v ) (!(v))
#endif

namespace BmsConst {
  // \
  const int DEFAULT_BAR_DIVISION_COUNT = 1;
  const int BAR_DIVISION_COUNT_MAX = 13440;

  const int HEX36_MIN_VALUE = 0;
  const int HEX36_MAX_VALUE = 35;
  const int HEX36_MAX_COUNT = 36;

  const int WORD_MIN_VALUE = 0;
  const int WORD_MAX_VALUE = 1295;
  const int WORD_MAX_COUNT = 1296;

  const int BAR_MAX_VALUE = 999;
  const int BAR_MAX_COUNT = 1000;
}

#ifdef DEBUG
#  include <stdio.h>
#  define PCD()            printf( "%s(%d) gone.\n", __FILE__, __LINE__ );
#  define PCA( type, obj ) printf( "%s(%d) : %s = " type "\n", __FILE__, __LINE__, #obj, obj )
#  define PCC( c )         PCA( "%c", c )
#  define PCI( i )         PCA( "%d", i )
#  define PCP( p )         PCA( "%p", p )
#  define PCS( s )         PCA( "%s", s )
#  define PCF( f )         PCA( "%f", f )
#endif

#endif // BMSBEL_DEFINE_H_
